package com.sso.login.controller;

import com.sso.login.pojo.User;
import com.sso.login.utils.LogCacheUtil;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.thymeleaf.util.StringUtils;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.util.*;

@Controller
@RequestMapping("/login")
public class LoginController {
//    模拟数据库拿的信息
    private static Set<User> dbUser;

    static{
        dbUser = new HashSet<>();
        dbUser.add(new User(1,"xiaoqiang","123456"));
        dbUser.add(new User(2,"alice","987654"));
    }

    /**
     * 判断登录是否成功
     * @param user
     * @param session
     * @param response
     * @return
     */
    @PostMapping
    public String doLogin(User user, HttpSession session, HttpServletResponse response){
        String target = (String) session.getAttribute("target");
        Optional<User> first = dbUser.stream().filter(dbUser -> dbUser.getUsername().equals(user.getUsername()) &&
                dbUser.getPassword().equals(user.getPassword()))
                .findFirst();
        if(first.isPresent()){
            //登陆成功。返回信息
            String token = UUID.randomUUID().toString();
            Cookie cookie=new Cookie("TOKEN",token);
            //定义域为codeshop.com
            cookie.setDomain("codeshop.com");
            response.addCookie(cookie);
            LogCacheUtil.loginUser.put(token, first.get());
        }else{
            //登录失败时不跳转
            session.setAttribute("msg","username or password is wrong.");
            return "login";
        }

        //重定向到target地址
        return "redirect:" + target;
    }


    @GetMapping("info")
    @ResponseBody
    public ResponseEntity<User> getUserInfo(String token){
        //不为空时相应
        if (!StringUtils.isEmpty(token)){
            User user=LogCacheUtil.loginUser.get(token);
            return ResponseEntity.ok(user);
        }else {
        //为空时返回错误
            return new ResponseEntity<>(null, HttpStatus.BAD_REQUEST);
        }
    }
}
